
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>简单入门循环神经网络RNN：时间序列数据的首选神经网络 / iVAN</title>

    <meta name="description" content="简单入门循环神经网络RNN：时间序列数据的首选神经网络 更多深度文章,请关注:https://yq.aliyun.com/cloud 随着科学技术的发展以及硬件计算能力的大幅提升,人工智能已经从几十年的幕后工作一下子跃入人们眼帘.人工智能的背后源自于大数据.高性能的硬件与优秀的算法的支持.2016年,深度学习已成为Google搜索的热词,随着最近一两年的围棋人机大战中,阿法狗完胜世界冠军后,人们感觉到再也无法抵挡住AI的车轮的快速驶来.在2017年这一年中,AI已经突破天际,相关产品也出现在人们的生活中,比如智能机器人.无人驾驶以及语音搜索等.最近,">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">简单入门循环神经网络RNN：时间序列数据的首选神经网络</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><b>更多深度文章，请关注：</b><b><u>https://yq.aliyun.com/cloud</u></b></p>
<p>随着科学技术的发展以及硬件计算能力的大幅提升，人工智能已经从几十年的幕后工作一下子跃入人们眼帘。人工智能的背后源自于大数据、高性能的硬件与优秀的算法的支持。2016年，深度学习已成为Google搜索的热词，随着最近一两年的围棋人机大战中，阿法狗完胜世界冠军后，人们感觉到再也无法抵挡住AI的车轮的快速驶来。在2017年这一年中，AI已经突破天际，相关产品也出现在人们的生活中，比如智能机器人、无人驾驶以及语音搜索等。最近，世界智能大会在天津举办成功，大会上许多业内行家及企业家发表自己对未来的看法，可以了解到，大多数的科技公司及研究机构都非常看好人工智能的前景，比如百度公司将自己的全部身家压在人工智能上，不管破釜沉舟后是一举成名还是一败涂地，只要不是一无所获就行。为什么突然之间深度学习会有这么大的效应与热潮呢？这是因为科技改变生活，很多的职业可能在今后的时间里慢慢被人工智能所取代。全民都在热议人工智能与深度学习，就连Yann LeCun大牛都感受到了人工智能在中国的火热!</p>
<p><b></b><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2NlNTI1ZjFkODBkYTUzNGE1ZTFlY2RjNzA4MTVkMGVhMjRiZTMwMzUucG5n.jpg"><b></b><b></b></p>
<p>言归正传，人工智能的背后是大数据、优秀的算法以及强大运算能力的硬件支持。比如，英伟达公司凭借自己的强大的硬件研发能力以及对深度学习框架的支持夺得世全球最聪明的五十家公司榜首。另外优秀的深度学习算法有很多，时不时就会出现一个新的算法，真是令人眼花缭乱。但大多都是基于经典的算法改进而来，比如卷积神经网络（CNN）、深度信念网络（DBN）、循环神经网络（RNN）等等。</p>
<p>本文将介绍经典的网络之循环神经网络（RNN），这一网络也是时序数据的首选网络。当涉及某些顺序机器学习任务时，RNN可以达到很高的精度，没有其他算法可以与之一较高下。这是由于传统的神经网络只是具有一种短期记忆，而RNN具有有限的短期记忆的优势。然而，第一代RNNs网络并没有引起人们着重的注意，这是由于研究人员在利用反向传播和梯度下降算法过程中遭受到了严重的梯度消失问题，阻碍了RNN几十年的发展。最后，于90年代后期出现了重大突破，导致更加准确的新一代RNN的问世。基于这一突破的近二十年，直到<a href="https://research.googleblog.com/2015/08/the-neural-networks-behind-google-voice.html" rel="external nofollow noreferrer"><u>Google Voice Search</u></a>和<a href="http://bgr.com/2016/06/13/ios-10-siri-third-party-apps/" rel="external nofollow noreferrer"><u>Apple Siri</u></a>等应用程序开始抢夺其关键流程，开发人员完善和优化了新一代的RNN。现在，RNN网络遍布各个研究领域，并且正在帮助点燃人工智能的复兴之火。</p>
<p><b>与过去有关的神经网络（RNN）</b><b></b></p>
<p><b><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzk3ZTA5N2FiMTZiN2E3YjA0NTQxYjBhZTIyZDA5NDQ1NjFiYmRiYjQucG5n.jpg"></b><b></b></p>
<p>大多数人造神经网络，如前馈神经网络，都没有记忆它们刚刚收到的输入。例如，如果提供前馈神经网络的字符“WISDOM”，当它到达字符“D”时，它已经忘记了它刚刚读过字符“S”，这是一个大问题。无论训练该网络是多么的辛苦，总是很难猜出下一个最有可能的字符“O”。这使得它成为某些任务的一个相当无用的候选人，例如在语音识别中，识别的好坏在很大程度上受益于预测下一个字符的能力。另一方面，RNN网络确实记住了之前的输入，但是处于一个非常复杂的水平。</p>
<p>我们再次输入“WISDOM”，并将其应用到一个复发性网络中。RNN网络中的单元或人造神经元在接收到“D”时也将其之前接收到的字符“S”作为其输入。换句话说，就是把刚刚过去的事情联合现在的事情作为输入，来预测接下来会发生的事情，这给了它有限的短期记忆的优势。当训练时，提供足够的背景下，可以猜测下一个字符最有可能是“O”。<br /><b>调整和重新调整</b><br />    像所有人工神经网络一样，RNN的单元为其多个输入分配一个权重矩阵，这些权重代表各个输入在网络层中所占的比重；然后对这些权重应用一个函数来确定单个输出，这个函数一般被称为损失函数（代价函数），限定实际输出与目标输出之间的误差。然而，循环神经网络不仅对当前输入分配权重，而且还从对过去时刻输入分配权重。然后，通过使得损失函数最下来动态的调整分配给当前输入和过去输入的权重，这个过程涉及到两个关键概念：梯度下降和反向传播（BPTT）。<br /><b>梯度下降</b><br />    机器学习中最著名的算法之一就是梯度下降算法。它的主要优点在于它显着的回避了“维数灾难”。什么是“维数灾难”呢，就是说在涉及到向量的计算问题中，随着维数的增加，计算量会呈指数倍增长。这个问题困扰着诸多神经网络系统，因为太多的变量需要计算来达到最小的损失函数。然而，梯度下降算法通过放大多维误差或代价函数的局部最小值来打破维数灾难。这有助于系统调整分配给各个单元的权重值，以使网络变得更加精确。<br /><b>通过时间</b><b>的反向传播</b><br />    RNN通过反向推理微调其权重来训练其单元。简单的说，就是根据单元计算出的总输出与目标输出之间的误差，从网络的最终输出端反向逐层回归，利用损失函数的偏导调整每个单元的权重。这就是著名的BP算法，关于BP算法可以看本博主之前的相关博客。而RNN网络使用的是类似的一个版本，称为通过时间的反向传播（BPTT）。该版本扩展了调整过程，包括负责前一时刻（T-1）输入值对应的每个单元的记忆的权重。<br /><b>Yikes：梯度消失问题 </b></p>
<p><b></b><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzEwZTNlOTBmNzkxODEwMDQxZGFjY2RjODBjOTE3YjJlNGE5MWVjNWIuanBlZw==.jpg"><b></b><b></b></p>
<p>尽管在梯度下降算法和BPTT的帮助下享有一些初步的成功，但是许多人造神经网络（包括第一代RNNs网络），最终都遭受了严重的挫折——梯度消失问题。什么是梯度消失问题呢，其基本思想其实很简单。首先，来看一个梯度的概念，将梯度视为斜率。在训练深层神经网络的背景中，梯度值越大代表坡度越陡峭，系统能够越快地下滑到终点线并完成训练。但这也是研究者陷入困境的地方——当斜坡太平坦时，无法进行快速的训练。这对于深层网络中的第一层而言特别关键，因为若第一层的梯度值为零，说明没有了调整方向，无法调整相关的权重值来最下化损失函数，这一现象就是“消梯度失”。随着梯度越来越小，训练时间也会越来越长，类似于物理学中的沿直线运动，光滑表面，小球会一直运动下去。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2NiOTM2YzkxZWFkM2Y1YmQxYzE1OWY2MjhhZWY0ODQ0ODExYzlkMDIucG5n.jpg"></p>
<p><b>大的突破：长短期记忆（LSTM）</b><br />在九十年代后期，一个重大的突破解决了上述梯度消失问题，给RNN网络发展带来了第二次研究热潮。这种大突破的中心思想是引入了单元长短期记忆（LSTM）。 </p>
<p><b></b><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2YwMTk5YzU4ZGM4NjA5NDhlMmVlODMyMzNjN2JiOWI5MzgwYTZlYzkucG5n.jpg"><b></b><b></b></p>
<p>LSTM的引入给AI领域创造了一个不同的世界。这是由于这些新单元或人造神经元（如RNN的标准短期记忆单元）从一开始就记住了它们的输入。然而，与标准的RNN单元不同，LSTM可以挂载在它们的存储器上，这些存储器具有类似于常规计算机中的存储器寄存器的读/写属性。另外LSTM是模拟的，而不是数字，使得它们的特征可以区分。换句话说，它们的曲线是连续的，可以找到它们的斜坡的陡度。因此，LSTM特别适合于反向传播和梯度下降中所涉及的偏微积分。 </p>
<p><b></b><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzNmZjAxYzgzN2Y1NGJiNDY4MzhhZWEwNTVkYjIyOWU1YWJmYzMzMDMucG5n.jpg"><b></b><b></b></p>
<p>总而言之，LSTM不仅可以调整其权重，还可以根据训练的梯度来保留、删除、转换和控制其存储数据的流入和流出。最重要的是，LSTM可以长时间保存重要的错误信息，以使梯度相对陡峭，从而网络的训练时间相对较短。这解决了梯度消失的问题，并大大提高了当今基于LSTM的RNN网络的准确性。由于RNN架构的显著改进，谷歌、苹果及许多其他先进的公司现在正在使用RNN为其业务中心的应用提供推动力。<br /><b>总结</b></p>
<ul>
<li>循环神经网络（RNN）可以记住其以前的输入，当涉及到连续的、与上下文相关的任务（如语音识别）时，它比其他人造神经网络具有更大的优势。</li>
<li>关于RNN网络的发展历程：第一代RNNs通过反向传播和梯度下降算法达到了纠正错误的能力。但梯度消失问题阻止了RNN的发展；直到1997年，引入了一个基于LSTM的架构后，取得了大的突破。</li>
<li>新的方法有效地将RNN网络中的每个单元转变成一个模拟计算机，大大提高了网络精度。</li>
</ul>
<p><b>作者信息</b></p>
<p>Jason Roell：软件工程师，热爱深度学习及其可改变技术的应用。</p>
<p>Linkedin：<a href="http://www.linkedin.com/in/jason-roell-47830817/" rel="external nofollow noreferrer"><u>http://www.linkedin.com/in/jason-roell-47830817/</u></a></p>
<p>文章原标题《Understanding Recurrent Neural Networks: The Preferred Neural Network for Time-Series Data》，作者：Jason Roel，译者：海棠，审阅：袁虎</p>
<p>附件为原文的pdf</p>
<p><b>文章为简译，更为详细的内容，请查看</b><a href="https://medium.com/towards-data-science/understanding-recurrent-neural-networks-the-prefered-neural-network-for-time-series-data-7d856c21b759" rel="external nofollow noreferrer"><b><u>原文</u></b></a></p>
<p> </p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-27 08:46:23</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%b7%b1%e5%ba%a6%e5%ad%a6%e4%b9%a0/" title="深度学习">深度学习</a>, <a href="https://www.iamivan.net/tag/%e6%9c%ba%e5%99%a8%e5%ad%a6%e4%b9%a0/" title="机器学习">机器学习</a>, <a href="https://www.iamivan.net/tag/%e8%af%ad%e9%9f%b3%e8%af%86%e5%88%ab/" title="语音识别">语音识别</a>, <a href="https://www.iamivan.net/tag/lstm/" title="LSTM">LSTM</a>, <a href="https://www.iamivan.net/tag/rnn/" title="RNN">RNN</a>, <a href="https://www.iamivan.net/tag/%e5%be%aa%e7%8e%af%e7%a5%9e%e7%bb%8f%e7%bd%91%e7%bb%9c/" title="循环神经网络">循环神经网络</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>简单入门循环神经网络RNN：时间序列数据的首选神经网络的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3rva7z.html" rel="bookmark">循环递归RNN，序列建模套路深（深度学习入门系列之十三）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				系列文章一入侯门&quot;深&quot;似海,深度学习深几许(入门系列之一)人工&quot;碳&quot;索意犹尽,智能&quot;硅&quot;来未可知(深度学习入门系列之二)神经网络不胜语, M-P模型似可寻(深度学习入门系列之三)&quot;机器学习&quot;三重门,&quot;中庸之道&quot;趋若人(深度学习入门系列之四)Hello World感知机,懂你我心才安息(深度学习入门系列之五)损失函数减肥用,神经网络调权重(深度学习入门系列之六)山重水复疑无路,最快下降问梯度(深度学习入门系列			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8Jrl4b.html" rel="bookmark">循环神经网络&lpar;RNN&comma; Recurrent Neural Networks&rpar;介绍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				循环神经网络(RNN, Recurrent Neural Networks)介绍    这篇文章很多内容是参考:http://www.wildml.com/2015/09/recurrent-neural-networks-tutorial-part-1-introduction-to-rnns/,在这篇文章中,加入了一些新的内容与一些自己的理解.   循环神经网络(Recurrent Neural Networks,RNNs)已经在众多自然语言处理(Natural Language Proce			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6ZwDLM.html" rel="bookmark">简单入门&mdash;&mdash;深度学习笔记（Part II）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				更多深度文章,请关注:https://yq.aliyun.com/cloud 作者介绍:Deepak Shah Deepak Shah毕业于德克萨斯奥斯汀分校,徒步旅行爱好者,目前是深度学习\数据科学实习生,研究领域专注于深度学习.编程.金融等方面. 个人主页:http://www.deepakvshah.com/ Medium论坛:https://medium.com/@dvshah13 Github论坛:https://github.com/Dvshah13  笔记分为两个部分,本文是笔记P			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bo6kmgz.html" rel="bookmark">Ruby中的Socket编程简单入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  这篇文章主要介绍了Ruby中的Socket编程简单入门,是Ruby网络编程学习中的基础知识,需要的朋友可以参考下 Ruby提供了两个访问级别的网络服务.在一个较低的水平,可以访问底层的操作系统,它可以实现面向连接和无连接协议的客户端和服务器支持基本的socket. Ruby也具有程序库,提供更高级别的访问特定的应用程序级的网络协议,如FTP,HTTP等. 这篇教程介绍 Ruby Socket编程概念及讲解一个简单的实例. 什么是Sockets? 套接字是一个双向通信信道的端点.socket能			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEldLLz.html" rel="bookmark">Windows 8风格应用开发入门 二十七 漫游应用数据</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.漫游应用数据概览 1.若应用当中使用了漫游应用数据,用户可以很轻松的在不同的设备间保持应用数据的同步. 2.Windows会将更新的漫游数据同步到云端,并将数据更新到其他安装此应用的设备上. 3.Windows 限制了每个应用可漫游的应用数据大小.若我们的应用达到漫游数据大小的限制,在应用的总漫游数据再次少于该限制之前,不会将应用的任何数据更新到云端,因此最好的做法是仅为用户首选项.链接和小型数据文件使用漫游数据. 4.只要用户在所需的时间间隔内从某个设备访问应用的漫游数据,这些数据将存在云			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxWRwyb.html" rel="bookmark">rxjs简单入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				rxjs简单入门 rxjs全名Reactive Extensions for JavaScript,Javascript的响应式扩展, 响应式的思路是把随时间不断变化的数据.状态.事件等等转成可被观察的序列(Observable Sequence),然后订阅序列中那些Observable对象的变化,一旦变化,就会执行事先安排好的各种转换和操作 rxjs适用于异步场景,即前端交互中接口请求.浏览器事件以及自定义事件.通过使用rxjs带给我们前所未有的开发体验. 统一异步编程的规范,不管是Promi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLa6q5z.html" rel="bookmark">CI框架入门示例之数据库取数据完整实现方法&lowbar;php实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了CI框架入门示例之数据库取数据完整实现方法.是写给初学者看的,这是最简单可以调通的例子.分享给大家供大家参考.具体实现方法如下: 1.下载CI框架 2.配置 database.php配置: 为数据库服务器设置 connection 参数: 复制代码 代码如下: $db['default']['hostname'] = &quot;your-db-host&quot;;  $db['default']['username'] = &quot;your-username&quot;;  $db[			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0QNrmp.html" rel="bookmark">【java开发系列】&mdash;&mdash; struts2简单入门示例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:[java开发系列]-- struts2简单入门示例 上篇推荐:JDK安装 前言 最近正好有时间总结一下,过去的知识历程,虽说东西都是入门级的,高手肯定是不屑一顾了,但是对于初次涉猎的小白们,还是可以提供点参考的. struts2其实就是为我们封装了servlet,简化了jsp跳转的复杂操作,并且提供了易于编写的标签,可以快速开发view层的代码. 过去,我们用jsp和servlet搭配,实现展现时,答题的过程是: 1 jsp出发action 2 servlet接受action,交给后台c			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAAJv3M.html" rel="bookmark">C&num;简单查询SQLite数据库是否存在数据的方法&lowbar;C&num;教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了C#简单查询SQLite数据库是否存在数据的方法.分享给大家供大家参考,具体如下: //sqlite数据库驱动组件 using System.Data.SQLite; //插入数据库函数 int SQLquery(string sql) { try { //打开数据库 SQLiteConnection conn = new SQLiteConnection(); SQLiteConnectionStringBuilder connstr = new SQLiteConnection			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMArrep.html" rel="bookmark" class="title">在SQL 2005中用T-SQL插入中文数据时出现的问号或乱码的解决方案&lbrack;转&rsqb;</a>
					<div>
						在SQL 2005中用T-SQL插入中文数据时出现的问号或乱码的解决方案 病症表现为:主要表现为用T-sql语句插入中文数据时数据库显示全是问号&quot;???&quot; 解决办法: 第一种办法: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MWWw7M.html" rel="bookmark" class="title">HBase数据模型剖析</a>
					<div>
						欢迎访问我的个人网站:http://wuyudong.com/ HBase 进行数据建模的方式和你熟悉的关系型数据库有些不同.关系型数据库围绕表.列和数据类型--数据的形态使用严格的规则.遵守这些严格 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9ze9VVz.html" rel="bookmark" class="title">思科SAFE蓝图中科院海洋安全解决方案</a>
					<div>
						就在5年前,黑客和病毒还是新鲜词.如果什么地方被黑客攻击,或者出现什么新的病毒,肯定会成为热炒的新闻.可现在,黑客和病毒好象就在我们身边,随时都有爆发的可能.网络安全成了我们每个人心中的隐患,中科院海 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qbaRWPM.html" rel="bookmark" class="title">ASP&period;NET 2&period;0 和数据绑定控件：新的角度，新的做法</a>
					<div>
						asp.net|控件|数据 适用于:Microsoft ASP.NET 1.xMicrosoft ASP.NET 2.0 摘要:了解 ASP.NET 2.0 中的用于生成自定义数据绑定控件的工具是如何 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/apXnLjb.html" rel="bookmark" class="title">如何编写 Spring Roo 的高级附加组件和包装器附加组件</a>
					<div>
						本系列 &quot;Spring Roo 简介&quot; 的 Spring Roo 简介,第 3 部分:开发 Spring Roo 的附加组件 讨论了 Spring Roo 附 加架构,以及如何使用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVnW8Qz.html" rel="bookmark" class="title">Haskell中解决hslua unknown symbol &grave;&lowbar;&lowbar;&lowbar;s trtod&amp;&num;039&semi;的问题</a>
					<div>
						用cabal编译libpandoc时遇到这样的错误: HShslua-0.3.12.o: unknown symbol `___s trtod' ghc.exe: unable to load pac ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKVgOM.html" rel="bookmark" class="title">OE1、OE2、ON1和ON2路由区别</a>
					<div>
						OSPF的路由类型: 1 .O      域内路由 2 .OIA  域间路由 3 .OE1  域外路由,会累加METRIC值(默认20) 4 .OE2  域外路由,不累加METRIC值(默认20),由 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLWZYb.html" rel="bookmark" class="title">3dsmax用video post渲染功能做霓虹灯效果</a>
					<div>
						本文由中国教程网专栏作者海啸原创,转载必须保留此信息 大家可以按自己的方式设计,先看大楷效果,图片较大,若看不清楚.请点图片放大后阅读. 先建这样一个物体,我想大家都会吧．2点右键,打开属性面版 选你 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/balKLwz.html" rel="bookmark" class="title">测试运行&colon; 使用Team System自定义测试自动化</a>
					<div>
						测试软件的最佳方法不只一种.除手动测试外,根据您的具体开发环境,您可使用商业测试自动化框架.开放源代码和内部测试自动化框架,以及自定义测试自动化脚本.所有这些方法都各有优缺点. 自定义测试自动化脚本的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M91dRRM.html" rel="bookmark" class="title">Photoshop给外景森林照片添加梦幻星光效果</a>
					<div>
						Photoshop给外景森林照片添加梦幻星光效果   第一步:为了使照片更有梦幻的感觉,我们可以利用[滤镜]中的[高斯模糊]做出柔光的效果,高斯模糊的半径根据想要效果选择,之后更改图层的不透明度,这样 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1errz.html" rel="bookmark" class="title">win8中qq卡死怎么办</a>
					<div>
						腾讯QQ for Windows 8版本在Win8 Metro界面的体验目前并不是太好,除了没有中文,功能不齐全外,还有联系人列表出现卡死的BUG.腾讯官方给出了解决方法:Windows 8系统用户名 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2yXOZz.html" rel="bookmark" class="title">十大令人讨厌的编程语言排行</a>
					<div>
						为了避免引起语言之争,先声明一下,这个榜单统计的是跨语言开发者最讨厌的编程语言,比如你最喜欢使用A语言来编程,那么可能会对其他语言的某些特性看不惯. 这是一种很主观的看法,上榜的语言不代表这个语言不好 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0WlwAb.html" rel="bookmark" class="title">Win8如何设置鼠标相关属性</a>
					<div>
						  Win8设置鼠标相关属性的方法如下: 1.将鼠标移到屏幕右下角,在自动弹出的菜单中选择[设置]. 2.选择[控制面板]. 3.在控制面板中将查看方式选成[类别],点击[鼠标]. 4.在[鼠标属性] ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7v9xM.html" rel="bookmark" class="title">内存回收-android内存不足，系统杀死进程，如果在此之前准确知道快被回收？</a>
					<div>
						问题描述 android内存不足,系统杀死进程,如果在此之前准确知道快被回收? 各位大神: 情况是这样的,应用长时间切后台,会被系统杀掉,然而系统会记住被杀死时的那个activity,而因为上下文所有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7Y5qrM.html" rel="bookmark" class="title">hough 直线监测-hough变换检测直线不先边缘检测</a>
					<div>
						问题描述 hough变换检测直线不先边缘检测 hough变换中`BW=rgb2gray(BW); thresh=[0.010.17]; sigma=2;%定义高斯参数 f = edge(double( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgV5aOb.html" rel="bookmark" class="title">Json&mdash;&mdash;js和C&num;对Json的操作</a>
					<div>
						原文:Json--js和C#对Json的操作   JSON(JavaScript Object Notation) 是一种轻量级的数据交换格式,采用完全独立于语言的文本格式.博主记得几年前在华为外包项 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDWDV0p.html" rel="bookmark" class="title">PHP 开发框架 mzphp</a>
					<div>
						mzphp 详细介绍 mzphp 介绍 PHP 开发框架 mzphp,拥有特点: 性能,高性能极致加载.高效率编译和读取! 清晰,大量注释及实例,几分钟就上马进门! 小巧,整个框架 400k,几乎没有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDW1aBp.html" rel="bookmark" class="title">ascii-微型计算机能处理的最小数据单位是</a>
					<div>
						问题描述 微型计算机能处理的最小数据单位是 微型计算机能处理的最小数据单位是( ). ASCII码 比特(二进制位) 字节 字长 解决方案 根据你们老师的标准答案来说,选择&quot;比特&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b324qwz.html" rel="bookmark" class="title">详解使用 fastboot 为 Android 刷入原厂镜像</a>
					<div>
						如果你的手机有一个解锁的 bootloader 的话,你可以用 fastboot 命令来刷入原厂镜像.听起来这好像是外行弄不懂的东西,但是当你需要升级被 root 过的设备,修理坏掉的手机,恢复到原生 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvmJqVb.html" rel="bookmark" class="title">c语言-C语言计算1&plus;2&plus;3&plus;4&plus;&period;&period;&period;&plus;n的和，要使用至少3种不同的方法实现</a>
					<div>
						问题描述 C语言计算1+2+3+4+...+n的和,要使用至少3种不同的方法实现 C语言计算1+2+3+4+...+n的和,要使用至少3种不同的方法实现 解决方案 方法1: int sum = 0;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6ZvKOM.html" rel="bookmark" class="title">我的导航网站我来做主</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断淘宝客 站长团购 云主机 技术大厅 &quot;大千世界,无奇 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRDl83z.html" rel="bookmark" class="title">SharePoint 2013 版本功能对比</a>
					<div>
						原文:SharePoint 2013 版本功能对比 前言:在SharePoint使用中,经常纠结于版本问题,SharePoint 2013主要有免费的Foundation和收费的标准版.企业版三个版本 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M94DOVb.html" rel="bookmark" class="title">云计算化云为雨 开始落地金融服务业</a>
					<div>
						本文讲的是云计算化云为雨 开始落地金融服务业,短短几年间,云计算已经从一种多少有些云山雾罩的技术管理模式,转变为正在改变企业领导正确评估支撑其业务增长的底层技术的主要依据.但是在金融市场,云计算对于金 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXBR1z.html" rel="bookmark" class="title">Cray探索提供&OpenCurlyDoubleQuote;超级计算即服务&rdquo;</a>
					<div>
						Cray正在探索提供超级计算&quot;即服务&quot;的选择,但是不指望AWS立即就提供自己强大的计算系统. 相反,Cray正在考虑将其技术作为一项服务提供给客户,如果没有别的方式帮助客户至少减轻 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZBdL6z.html" rel="bookmark" class="title">格式-sql赋值语句insert问题</a>
					<div>
						问题描述 sql赋值语句insert问题 String username=request.getParameter(&quot;&quot;r_user&quot;&quot;);String pas ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWWWaEM.html" rel="bookmark" class="title">请哪位大神知道如何用VBA代码做word索引，求代码啊。。拜托拜托。。</a>
					<div>
						问题描述 请哪位大神知道如何用VBA代码做word索引,求代码啊..拜托拜托.. 请哪位大神知道如何用VBA(visual basic)代码做word索引,求代码啊..拜托拜托.. 解决方案 我也来个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyePRlM.html" rel="bookmark" class="title">cocos2d-js-用cocostudio打包的，求大神指点</a>
					<div>
						问题描述 用cocostudio打包的,求大神指点 Based on: cocos2d-x-3.8 Updated project.properties Updated local.propertie ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwJPjnp.html" rel="bookmark" class="title">急急急急</a>
					<div>
						问题描述 我做了个登录界面,用了button按钮作为&quot;登录&quot;.让这个界面和sql数据库连接,输入密码.名字完后,点击登录,怎么写代码啊?输入错了提示错了,对了的话弹出另一个界面.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJK33p.html" rel="bookmark" class="title">男人最爱看的10大杂志</a>
					<div>
						&lt;花花公子&gt;.&lt;男人帮&gt;.&lt;GQ&gt;,这些大名鼎鼎的男性杂志,不仅体现时尚,更代表一种男人的品味生活. 第一名:&lt;Playboy&gt; 创刊50周年的老牌男性 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnB3rM.html" rel="bookmark" class="title">HtmlAgilityPack  无可用源</a>
					<div>
						问题描述 HtmlAgilityPack.HtmlWebweb=newHtmlAgilityPack.HtmlWeb();这一句就挂掉了,提示无可用源源文件信息:为&quot;d:Sourcehtml ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.036 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
